
namespace eval last_activity {
	variable time
}

proc last_activity::save_time {path} {
	variable time
	
	set time [clock seconds]
}

hook::add lost_focus_hook \
	[namespace current]::last_activity::save_time

proc last_activity::reset_time {path} {
	variable time
	
	set time 0
}

hook::add got_focus_hook \
	[namespace current]::last_activity::reset_time

proc last_activity::iq {connid from lang child} {
	variable time
	global userstatus statusdesc textstatus

	jlib::wrapper:splitxml $child tag vars isempty chdata children

	puts "My handler"

	if {$::plugins::options(reply_iq_last)} {
		set seconds [expr [clock seconds] - $time]
		set status $statusdesc($userstatus)
		if {[cequal $textstatus ""]} {
			set status "$statusdesc($userstatus) ($userstatus)"
		} else {
			set status "$textstatus ($userstatus)"
		}
		return [list result [jlib::wrapper:createtag query \
			-vars [list xmlns jabber:iq:last seconds $seconds] \
			-chdata $status]]
	} else {
		return [list error cancel service-unavailable]
	}
}

iq::register_handler get query jabber:iq:last \
	[namespace current]::last_activity::iq
